
#define IS_MP3(%1)				bool:(equali(%1[strlen(%1) - 4], ".mp3"))
#define IS_WAV(%1)				bool:(equali(%1[strlen(%1) - 4], ".wav"))

#define VALID_PLAYER(%1)		(1 <= %1 <= MaxClients)

#define TASK_BOMB				1489

#include <amxmodx>
#include <reapi>
#include <nvault>
#include <warmup_rbs>


// хранится в data/vault/_music_control.vault
new const VAULT[] = "_music_control";


enum {
	WARMUP_DISABLE = 0,
	WARMUP_ENABLE,
};

enum (+=1)
{
	SectionNone = -1,
	Command,
	MusicConnection,
	MusicRound,
	MusicWarmUp,
	SampleKill,
	SampleHeadshot,
	SampleGrenade,
	SampleKnife,
	SampleSuicide,
	SampleBomb,
	
};	new g_Section;

new Array:g_MusicConnection, Array:g_MusicRound, Array:g_MusicWarmUp;
new Array:g_SampleKill, Array:g_SampleHeadshot, Array:g_SampleGrenade, Array:g_SampleKnife, Array:g_SampleSuicide;
new Trie:g_SampleBomb;

new g_MusicConnectionNum, g_MusicRoundNum, g_MusicWarmUpNum;
new g_SampleKillNum, g_SampleHeadshotNum, g_SampleGrenadeNum, g_SampleKnifeNum, g_SampleSuicideNum;

new g_bDisableMusicOfRoundEnd[MAX_PLAYERS + 1], g_iCounter[MAX_PLAYERS + 1];
new g_iCountDown;
new g_iVault;

// Last additions
new Float:g_flLastSuicideTime, Float:g_flLastGrenadeTime;

// get_member_game(m_iC4Timer)
new mp_c4timer, mp_c4timer_pointer;


public plugin_precache()
{
	register_plugin("Music Control", "0.1", "Impossible");
	
	g_MusicConnection = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_MusicRound = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_MusicWarmUp = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_SampleKill = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_SampleHeadshot = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_SampleGrenade = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_SampleKnife = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	g_SampleSuicide = ArrayCreate(MAX_RESOURCE_PATH_LENGTH, 0);
	
	g_SampleBomb = TrieCreate();
	
	new szCfgDir[PLATFORM_MAX_PATH];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	add(szCfgDir, charsmax(szCfgDir), "/music_control.ini");

	if (!file_exists(szCfgDir))
		set_fail_state("Configuration file '%s' not found", szCfgDir);
	
	if (!parseConfigINI(szCfgDir))
		set_fail_state("Fatal parse error!");
	
	if (g_MusicConnection)
		server_print("[Music Control] Загружено %i звуков при коннекте", g_MusicConnectionNum = ArraySize(g_MusicConnection));
	
	if (g_MusicRound)
		server_print("[Music Control] Загружено %i звуков в конце раунда", g_MusicRoundNum = ArraySize(g_MusicRound));
	
	if (g_MusicWarmUp)
		server_print("[Music Control] Загружено %i звуков во время разминки", g_MusicWarmUpNum = ArraySize(g_MusicWarmUp));
		
	if (g_SampleKill)
		server_print("[Music Control] Загружено %i звуков при убийстве", g_SampleKillNum = ArraySize(g_SampleKill));
	
	if (g_SampleHeadshot)
		server_print("[Music Control] Загружено %i звуков при убийстве в голову", g_SampleHeadshotNum = ArraySize(g_SampleHeadshot));
	
	if (g_SampleGrenade)
		server_print("[Music Control] Загружено %i звуков при убийстве с гранаты", g_SampleGrenadeNum = ArraySize(g_SampleGrenade));
	
	if (g_SampleKnife)
		server_print("[Music Control] Загружено %i звуков при убийстве с ножа", g_SampleKnifeNum = ArraySize(g_SampleKnife));
	
	if (g_SampleSuicide)
		server_print("[Music Control] Загружено %i звуков при суициде", g_SampleSuicideNum = ArraySize(g_SampleSuicide));
	
	if (g_SampleBomb)
		server_print("[Music Control] Загружено %i звуков отсчёта бомбы", TrieGetSize(g_SampleBomb));
	

	mp_c4timer_pointer = get_cvar_pointer("mp_c4timer");
	
	bind_pcvar_num(mp_c4timer_pointer, mp_c4timer);
	hook_cvar_change(mp_c4timer_pointer, "@change_cvar_callback");
}

public plugin_init()
{
	RegisterHookChain(RG_CSGameRules_RestartRound, "abc", true);
	RegisterHookChain(RG_CBasePlayer_Killed, "CBasePlayer_Killed", true);
	RegisterHookChain(RG_RoundEnd, "CSGameRules_RoundEnd", true);
	
	if (get_member_game(m_bMapHasBombTarget) && g_SampleBomb)
		RegisterHookChain(RG_PlantBomb, "CSGameRules_PlantBomb", true);
	
	if ((g_iVault = nvault_open(VAULT)) != INVALID_HANDLE)
	{
		// Удаляет не активных игроков которые не заходили на серв больше недели (7 дней)
		nvault_prune(g_iVault, 0, get_systime() - (86400 * 7));
	}
	else
	{
		set_fail_state("[!] Failed opened nVault file!");
	}
}

public client_connect(id)
{
	if (!g_MusicRoundNum)
		return;
	
	if (is_user_bot(id)
		|| is_user_hltv(id)
	)
		return;
	
	UTIL_PlaySample(id, fmt("%a", ArrayGetStringHandle(g_MusicConnection, random(g_MusicConnectionNum))), true);
}

public client_authorized(id, const szAuth[])
{
	g_bDisableMusicOfRoundEnd[id] = nvault_get(g_iVault, szAuth);
}

public client_disconnected(id)
{
	g_iCounter[id] = 0;
	
	new szAuth[MAX_AUTHID_LENGTH];
	get_user_authid(id, szAuth, charsmax(szAuth))
	{
		nvault_set(g_iVault, szAuth, fmt("%i", g_bDisableMusicOfRoundEnd[id]));
	}
}

public clcmd_toggle_music(id)
{
	client_print_color(id, print_team_default, "Музыка в конце раунда^3 %s", (g_bDisableMusicOfRoundEnd[id] ^= 1) ? "отключёна" : "включена");
}

public CBasePlayer_Killed(pPlayer, pevAttacker)
{
	g_iCounter[pPlayer] = 0;
	
	if (get_member(pPlayer, m_bKilledByBomb))
		return;
	
	new Float:time = get_gametime();
	
	if (pPlayer == pevAttacker || !VALID_PLAYER(pevAttacker))
	{
		if (!g_SampleSuicideNum)
			return;
		
		if (time - g_flLastSuicideTime < 0.35)
			return;
		
		g_flLastSuicideTime = time;
		UTIL_PlaySample(0, fmt("%a", ArrayGetStringHandle(g_SampleSuicide, random(g_SampleSuicideNum))));
	}
	else
	{
		g_iCounter[pevAttacker]++;
		
		new pWeapon = get_member(pevAttacker, m_pActiveItem);
		
		if (!is_nullent(pWeapon) && get_member(pWeapon, m_iId) == CSW_KNIFE)
		{
			if (g_SampleKnifeNum)
			{
				UTIL_PlaySample(0, fmt("%a", ArrayGetStringHandle(g_SampleKnife, random(g_SampleKnifeNum))));			
				return;
			}
		}
		
		if (get_member(pPlayer, m_bKilledByGrenade))
		{
			if (g_SampleGrenadeNum)
			{
				if (time - g_flLastGrenadeTime < 0.35)
					return;
				
				g_flLastGrenadeTime = time;
				UTIL_PlaySample(0, fmt("%a", ArrayGetStringHandle(g_SampleGrenade, random(g_SampleGrenadeNum))));			
				return;
			}
		}
		
		if (get_member(pPlayer, m_bHeadshotKilled))
		{
			if (g_SampleHeadshotNum)
			{
				UTIL_PlaySample(pevAttacker, fmt("%a", ArrayGetStringHandle(g_SampleHeadshot, random(g_SampleHeadshotNum))));			
				return;
			}
		}
		
		UTIL_PlaySample(pevAttacker, fmt("%a", ArrayGetStringHandle(g_SampleKill, min(g_SampleKillNum - 1, g_iCounter[pevAttacker] - 1))));
	}
}

public warmup_mode(type)
{
	if (!g_MusicWarmUpNum)
		return;
	
	if (type == WARMUP_DISABLE)
		UTIL_PlaySample(0, NULL_STRING, true);
	else if (type == WARMUP_ENABLE)
		UTIL_PlaySample(0, fmt("%a", ArrayGetStringHandle(g_MusicWarmUp, random(g_MusicWarmUpNum))), true);
}

public abc()
{
	arrayset(g_iCounter, 0, sizeof(g_iCounter));
	g_iCountDown = 0;
	
	remove_task(TASK_BOMB);
}

public CSGameRules_RoundEnd(WinStatus:status, ScenarioEventEndRound:event, Float:delay)
{
/*
	arrayset(g_iCounter, 0, sizeof(g_iCounter));
	g_iCountDown = 0;
	
	// Fixes
	remove_task(TASK_BOMB);
*/

	if (!g_MusicRoundNum)
		return;
	
	new sample[MAX_RESOURCE_PATH_LENGTH], aPlayers[MAX_PLAYERS], pNum;
	ArrayGetString(g_MusicRound, random(g_MusicRoundNum), sample, charsmax(sample));
	get_players(aPlayers, pNum, "ch");
	
	for (--pNum; pNum >= 0; pNum--)
	{
		if (g_bDisableMusicOfRoundEnd[aPlayers[pNum]])
			continue;
		
		UTIL_PlaySample(aPlayers[pNum], sample, true);
	}
}

public CSGameRules_PlantBomb()
{
	g_iCountDown = mp_c4timer - 1; // get_member_game(m_iC4Timer);
	set_task(1.0, "@c4_timer", TASK_BOMB, .flags = "b");
}

@c4_timer()
{
	if (--g_iCountDown > 0)
	{
		new sample[MAX_RESOURCE_PATH_LENGTH];
		if (TrieGetString(g_SampleBomb, fmt("%i", g_iCountDown), sample, charsmax(sample)))
			UTIL_PlaySample(0, sample);
	}
	else
		remove_task(TASK_BOMB);
}

UTIL_PlaySample(id, sample[], bool:stop_previous_sound = false)
{
	if (stop_previous_sound)
		client_cmd(id, "stopsound; mp3 stop");
	
	if (!sample[0])
		return;
	
	if (IS_MP3(sample))
		client_cmd(id, "mp3 play ^"sound/%s^"", sample);
	else
		client_cmd(id, "spk ^"%s^"", sample);
}

bool:parseConfigINI(const configFile[])
{
	new INIParser:parser = INI_CreateParser();

	if (parser != Invalid_INIParser)
	{
		INI_SetReaders(parser, "ReadCFGKeyValue", "ReadCFGNewSection");
		INI_ParseFile(parser, configFile);
		INI_DestroyParser(parser);
		return true;
	}

	return false;
}

public bool:ReadCFGNewSection(INIParser:handle, const section[], bool:invalid_tokens, bool:close_bracket)
{
	if (!close_bracket)
	{
		log_amx("Closing bracket was not detected! Current section name '%s'.", section);
		return false;
	}

	if (equal(section, "command"))
	{
		g_Section = Command;
		return true;
	}
    
	if (equal(section, "music_connection"))
	{
		g_Section = MusicConnection;
		return true;
	}
    
	if (equal(section, "music_round"))
	{
		g_Section = MusicRound;
		return true;
	}
	
	if (equal(section, "music_warmup"))
	{
		g_Section = MusicWarmUp;
		return true;
	}
	
	if (equal(section, "sound_kill"))
	{
		g_Section = SampleKill;
		return true;
	}
	
	if (equal(section, "sound_headshot"))
	{
		g_Section = SampleHeadshot;
		return true;
	}
	
	if (equal(section, "sound_grenade"))
	{
		g_Section = SampleGrenade;
		return true;
	}
	
	if (equal(section, "sound_knife"))
	{
		g_Section = SampleKnife;
		return true;
	}
	
	if (equal(section, "sound_suicide"))
	{
		g_Section = SampleSuicide;
		return true;
	}
	
	if (equal(section, "sound_bomb"))
	{
		g_Section = SampleBomb;
		return true;
	}
	
	return false;
}

public bool:ReadCFGKeyValue(INIParser:handle, const key[], const value[])
{
	//new sample[MAX_RESOURCE_PATH_LENGTH];
	
	switch (g_Section)
	{
		case SectionNone:
			return false;
        
        case Command:
		{
			if (key[0] == '/' || key[0] == '!' || key[0] == '.')
			{
				register_clcmd(fmt("say %s", key), "clcmd_toggle_music");
				register_clcmd(fmt("say_team %s", key), "clcmd_toggle_music");
			}
			else
			{
				register_clcmd(key, "clcmd_toggle_music");
			}
        }
		
		case MusicConnection:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_MusicConnection, key);
		}
		
		case MusicRound:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_MusicRound, key);
		}
		
		case MusicWarmUp:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_MusicWarmUp, key);
		}
		
		case SampleKill:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_SampleKill, key);
		}
		
		case SampleHeadshot:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_SampleHeadshot, key);
		}
		
		case SampleGrenade:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_SampleGrenade, key);
		}
		
		case SampleKnife:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_SampleKnife, key);
		}
		
		case SampleSuicide:
		{
			if ((key[0] && !IS_WAV(key)) && (key[0] && !IS_MP3(key)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", key);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", key)))
			{
				if (IS_MP3(key))
					precache_generic(fmt("sound/%s", key));
				else
					precache_sound(key);
			}
			
			ArrayPushString(g_SampleSuicide, key);
		}
		
		case SampleBomb:
		{
			if ((value[0] && !IS_WAV(value)) && (value[0] && !IS_MP3(value)))
			{
				log_amx("Invalid sound file! Parse string '%s'. Only sound files in wav or mp3 format should be used!", value);
				return false;
			}
			
			if (file_exists(fmt("sound/%s", value)))
			{
				if (IS_MP3(value))
					precache_generic(fmt("sound/%s", value));
				else
					precache_sound(value);
			}
			
			TrieSetString(g_SampleBomb, key, value);
		}
	}

	return true;
}

@change_cvar_callback(pcvar, const old_value[], const new_value[])
{
	if (pcvar == mp_c4timer_pointer)
		mp_c4timer = str_to_num(new_value);
}
